/*
TASK:square
LANG:C++
*/
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
 struct Point
{
       int x,y;   
};


 struct  Sq
{
      vector <Point> verts;
      double  d;
};

int n;
unsigned  graph[1000][1000];


Sq Fv(Point A, Point M)
{
   Sq S;
   Point B;
   int dx = M.x - A.x;
   int dy = M.y - A.y;
   
   B.x = M.x + dy;
   B.y = M.y - dx;
   S.verts.push_back(B);
   
   B.x = M.x + dx;
   B.y = M.y + dy;
   S.verts.push_back(B);
   
   B.x = M.x - dy;
   B.y = M.y + dx;
   S.verts.push_back(B);
   
   S.verts.push_back(A);
   S.d = 2*sqrt(dx*dx + dy*dy);
   return S;
}
bool is_in(Point A, Sq S)
{
         
     for(int i = 0; i < 4; i++)
        if(S.d < sqrt( (S.verts[i].x - A.x)*(S.verts[i].x - A.x) + (S.verts[i].y - A.y)*(S.verts[i].y - A.y)) )
             return false;
    return true;     
}

bool ac(Sq s1, Sq s2)
{
     for(int i = 0; i < 4; i++)
             if( is_in(s1.verts[i], s2))
                 return true;
      for(int i = 0; i < 4; i++)
             if( is_in(s2.verts[i], s1))
                 return true;
      return false;                 
}
int main()
{
    Point A,M;
    cin >> n;
    Sq s[n];
    for(int i = 0; i < n; i++)
    for(int j = 0 ; j < n; j++)
    graph[i][j] = (unsigned)-1;
    for(int i = 0 ; i < n; i++)
    {
            cin >> A.x >> A.y >> M.x >> M.y;
            s[i]  =  Fv(M,A);
            for(int j = 0; j < i; j++)
            if(ac(s[i],s[j]))
            {
                             graph[i][j] = 1;
                             graph[j][i] = 1;
            }
    }
    for(int k = 0; k < n; k++)
    for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++)
    if(graph[i][j] > graph[i][k] + graph[k][j])
                   graph[i][j] = graph[i][k] + graph[k][j];
    if(graph[0][n-1] == ((unsigned)-1))
                     cout << -1 << endl;
    else 
                     cout << graph[0][n-1] << endl;
    
    return 0;    
}

