/*
TASK: lucky
LANG: C++
*/
#include <iostream>
using namespace std;

long long gcd(long long a, long long b)
{
    if (b == 0) return a;
    else return gcd(b, a%b);
}

long long DP[14][9*14+1][9*14+1];

long long dp(int k, int redsum, int sum)
{
    if (k < 0) return (redsum == 1) && (sum == 0);
    if (sum < 0) return 0;
    
    long long &ret = DP[k][redsum][sum];
    if (ret != -1) return ret;
    
    ret = 0;
    for (int i = 0; i < 10; i++)
     ret += dp(k - 1, redsum/gcd(redsum, i), sum - i);
    return ret;
}

long long before(int *p, int n)
{
    long long ret = 0;
    for (int S = 1; S <= 9*n; S++)
    {
        int lefts = 0;
        long long leftp = 1;
    
        //int prevt = ret;
        for (int q = n-1; q >= 0; q--)
        { 
              for (int i = (q==(n-1)); i < p[q]; i++)
              {
                  long long t = dp(q-1, S/(int)gcd(S, leftp*i), S - lefts - i);
                  if (t > 0) ret += t;
              }
              lefts += p[q];
              leftp *= p[q];
        }
        for (int q = n-2; q >= 0; q--)
         for (int i = 1; i < 10; i++)
         {
             long long t = dp(q-1, S/gcd(S, i), S-i);
             if (t > 0)  ret += t;
         }
        //if (prevt != ret) cout << S << endl;
    }
    return ret;
}

int main()
{
    memset(DP, -1, sizeof(DP));
    /*int A[14], a;
    cin >> a; int N = 0;
    for (int i = 0; a; i++, N++) A[i] = a%10, a/=10;
     cout << before(A, N) << endl;
    */
    int A[14], B[14], N1 = 0, N2 = 0;
    long long a, b;
    cin >> a >> b; b++;
    for (int i = 0; a; i++, N1++)
     A[i] = a%10, a/=10;
    for (int i = 0; b; i++, N2++)
     B[i] = b%10, b/=10;
    
    cout << before(B, N2) - before(A, N1) << endl;
    //system("pause");
    return 0;
}
