/*
TASK:lucky
LANG:C++
*/
#include <list>
#include <ctime>
#include <functional>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <sstream>
#include <string>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <utility>
#include <queue>

using namespace std;

#define MP make_pair
#define x first
#define y second
#define PB push_back
#define ALL(v) (v).begin(),(v).end()
#define VI vector<int>
#define PQ priority_queue
#define VD vector<double>
#define LL long long
#define UI unsigned int
#define SZ size()
#define PD pair<double,double>
#define PI pair<int,int>
#define ULL unsigned long long
#define IT iterator
#define sign(x) (((x)>0)-((x)<0))
#define ABS(x) (((x)>0)?(x):(-(x)))
#define sqr(x) ((x)*(x))
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define pause system("pause")
#define Time (double)clock()/(double)CLOCKS_PER_SEC

//optim: const GO array

const LL MAXX=1000000000000000LL;
const int CNT=33500;

LL prod[CNT]; int pc,szLL;
int gomul[CNT][10];
map<LL,int> indexx;

vector<LL> dp[15][128];
bitset<CNT> used[15][128];



//brute force

inline LL product(LL xax)
{
        LL ret=1;
        while (xax) { ret*=xax%10LL; xax/=10LL; }
        return ret;
}
inline LL summ(LL xax)
{
       LL ret=0;
       while (xax) { ret+=xax%10LL; xax/=10LL; }
       return ret;
}

LL bruteforce(LL to)
{
    LL ret=0;
    for (int i=1;i<=to;i++)
     if (product(i)%summ(i)==0) ret++;
    return ret;
}



//original solution


void rec(LL tek)
{
     if (tek>=MAXX) return;
     if (indexx.find(tek)!=indexx.end()) return;
     prod[pc++]=tek;
     indexx[tek]=0;
     rec(tek*2);
     rec(tek*3);
     rec(tek*5);
     rec(tek*7);
}

LL solve(int pos,int sum,int mul)
{
             if (mul>=dp[pos][sum].SZ) dp[pos][sum].resize(mul+1);
             LL &ret=dp[pos][sum][mul];
             if (used[pos][sum][mul]) return ret;
             used[pos][sum][mul]=1;
             if (!pos) return ret=(sum)?(prod[mul]%(LL)sum==0):0;
             
             ret=0;
             for (int i=(sum==0);i<10;i++)
              ret+=solve(pos-1,sum+i,gomul[mul][i]);
             return ret;
}

LL Solve(LL A)
{
            if (A<=0) return 0;
            ostringstream ss; ss<<A;
            string s=ss.str();
            int sum=0; LL pr=1,ans=0;
            Repi(s.SZ)
             ans+=solve(i,0,1);
            Repi(s.SZ)
             {
                      int dig=s[i]-'0';
                      for (int j=(i==0);j<dig;j++)
                         ans+=solve(s.SZ-i-1,sum+j,indexx[pr*(LL)j]);
                      sum+=dig; pr*=(LL)dig;
             }
            if (pr%sum==0) ans++;
            return ans;
}

int main()
{
    rec(1);
    prod[pc++]=0;
    sort(prod,prod+pc);
    Repi(pc) indexx[prod[i]]=i;
    Repi(pc)
     Repj(10)
       if (prod[i]*(LL)j<MAXX)
        gomul[i][j]=indexx[prod[i]*(LL)j];
     
     
    //cout<<solve(2,0,1)<<" "<<bruteforce(99)<<endl; 
    
    LL A,B;
    cin>>A>>B;
    cout<<Solve(B)-Solve(A-1)<<"\n";
    
    //cout<<bruteforce(B)-bruteforce(A-1)<<endl;
    
    //cout<<Time<<endl;
    //pause;
    return 0;
}                                                                                                                                     
