/*
TASK: square
LANG: C++
*/
#include<iostream>
#include<fstream>
#include<cmath>
#include<queue>
#include<cstdio>
using namespace std;
#define eps 1e-9
struct point
{ double x;double y;};
struct sq1
{ point c;point v1,v2,v3,v4;};
point a[2];int n;
sq1 sq[1024];
bool d[1024][1024];
int used[1024];
queue <int> q;
void bfs()
{ 
  q.push(0);
  used[0]=1;
  while(!q.empty())
   { int t=q.front();
     //cout<<t<<endl;
     q.pop();
     int i;
     for(i=0;i<n;i++)
      if(!used[i]&&d[t][i]>0)
       { //cout<<i<<' '<<used[i]<<"=>>";
                             used[i]=used[t]+1;
         //cout<<used[i]<<endl;
         q.push(i);
       }
   }
} 
point fprd(point a0,point a1)
{   double A=a1.y-a0.y;
    //cout<<"A="<<A<<endl;
    double B=a0.x-a1.x;
    //cout<<"B="<<B<<endl;
    double C=-a0.x*(a1.y-a0.y)-a0.y*(a0.x-a1.x);
    //cout<<"C="<<C<<endl;
    //cout<<A<<' '<<B<<' '<<C<<endl;
    double au=(A*A+B*B);
    //cout<<"a="<<au<<endl;
    double bu=(2*B*C+2*A*B*a0.x-2*A*A*a0.y);
    //cout<<"b="<<bu<<endl;
    double K=(a1.x*a1.x+a1.y*a1.y-2*a1.x*a0.x-2*a1.y*a0.y);
    //cout<<"K="<<K<<endl;
    double cu=(C*C+2*A*a0.x*C-K*A*A);
    //cout<<"c="<<cu<<endl;
    double D=bu*bu-4*au*cu;
    //cout<<"D="<<D<<endl;
    point x1;point x2;
    x1.y=(-bu+sqrt(D))/(2*au);
    x1.x=((-B)*x1.y-C)/A;
    x2.y=(-bu-sqrt(D))/(2*au);
    x2.x=((-B)*x2.y-C)/A;
    if((x1.x-a[1].x<=eps)&&(x1.y-a[1].y<=eps))
     { return x2;
     }
    else
    { return x1;
    }
}
pair<point,point> fprp(point a0,point a1)
{  double A=a1.y-a0.y;
   double B=a0.x-a1.x;
   double C=-a0.x*(a1.y-a0.y)-a0.y*(a0.x-a1.x);
   double au=(A*A+B*B);
   //cout<<"a="<<au<<endl;
   double Z=B*a0.x-A*a0.y;
   double bu=(2*Z*A-2*B*A*a0.x-2*B*B*a0.y);
   //cout<<"b="<<bu<<endl;
   double K=(a1.x*a1.x+a1.y*a1.y-2*a1.x*a0.x-2*a1.y*a0.y);
   //cout<<"k="<<K<<endl;
   double cu=(Z*Z-2*B*Z*a0.x-K*B*B);
   //cout<<"c="<<cu<<endl;
   double D=bu*bu-4*au*cu;
   //cout<<"D="<<D<<endl;
    //cout<<"D="<<D<<endl;
    point x1;point x2;
    x1.y=(-bu+sqrt(D))/(2*au);
    x1.x=(Z+A*x1.y)/(B);
    x2.y=(-bu-sqrt(D))/(2*au);
    x2.x=(Z+A*x2.y)/(B);
    pair <point,point> res;
    res.first=x1;
    res.second=x2;
    return res;
    //cout<<x1.x<<' '<<x1.y<<' '<<x2.x<<' '<<x2.y<<endl;
}
double orient(point x,point x1,point x2)
{ double A=x2.y-x1.y;
  double B=x1.x-x2.x;
  double C=(-x1.x)*(x2.y-x1.y)-x1.y*(x1.x-x2.x);
  double res=A*x.x+B*x.y+C;
  if(res==0)
  { if((x.x!=x1.x&&x.y!=x1.y)&&(x.x!=x2.x&&x.y!=x2.y))
     return 1;
  }
  
  return res;   
      
}
bool is(sq1 q1,sq1 q2)
{ 
      if(orient(q1.v1,q2.v1,q2.v3)>=0&&orient(q1.v1,q2.v3,q2.v2)>=0&&orient(q1.v1,q2.v2,q2.v4)>=0&&orient(q1.v1,q2.v4,q2.v1)>=0)
          return 1;
      if(orient(q1.v2,q2.v1,q2.v3)>=0&&orient(q1.v2,q2.v3,q2.v2)>=0&&orient(q1.v2,q2.v2,q2.v4)>=0&&orient(q1.v2,q2.v4,q2.v1)>=0)
       return 1;
       if(orient(q1.v3,q2.v1,q2.v3)>=0&&orient(q1.v3,q2.v3,q2.v2)>=0&&orient(q1.v3,q2.v2,q2.v4)>=0&&orient(q1.v3,q2.v4,q2.v1)>=0)
       return 1;
       if(orient(q1.v4,q2.v1,q2.v3)>=0&&orient(q1.v4,q2.v3,q2.v2)>=0&&orient(q1.v4,q2.v2,q2.v4)>=0&&orient(q1.v4,q2.v4,q2.v1)>=0)   
        return 1;
        //cout<<"sshhh"<<endl;
    /* if((q1.v1.x>=q2.v1.x&&q1.v1.x<=q2.v2.x)&&(q1.v1.y>=q2.v1.y&&q1.v1.y<=q2.v2.y))
       return 1;
     if((q1.v1.x>=q2.v3.x&&q1.v1.x<=q2.v4.x)&&(q1.v1.y>=q2.v3.y&&q1.v1.y<=q2.v4.y))
          return 1;
          if((q1.v2.x>=q2.v1.x&&q1.v2.x<=q2.v2.x)&&(q1.v2.y>=q2.v1.y&&q1.v2.y<=q2.v2.y))
       return 1;
     if((q1.v2.x>=q2.v3.x&&q1.v2.x<=q2.v4.x)&&(q1.v2.y>=q2.v3.y&&q1.v2.y<=q2.v4.y))
          return 1;
     if((q1.v3.x>q2.v1.x&&q1.v3.x<q2.v2.x)&&(q1.v3.y>q2.v1.y&&q1.v3.y<q2.v2.y))
       return 1;
     if((q1.v3.x>q2.v3.x&&q1.v3.x<q2.v4.x)&&(q1.v3.y>q2.v3.y&&q1.v3.y<q2.v4.y))
          return 1;
          if((q1.v1.x>q2.v1.x&&q1.v1.x<q2.v2.x)&&(q1.v1.y>q2.v1.y&&q1.v1.y<q2.v2.y))
       return 1;
     if((q1.v4.x>q2.v3.x&&q1.v4.x<q2.v4.x)&&(q1.v4.y>q2.v3.y&&q1.v4.y<q2.v4.y))
          return 1;
     
      
      */
      
        
  return 0;
}      
int main()
{ 
    //ifstream in("in.in");
    int i;
    scanf("%d",&n);
    for(i=0;i<n;i++)
    { 
                    scanf("%lf %lf %lf %lf",&a[0].x,&a[0].y,&a[1].x,&a[1].y);
      point m=fprd(a[0],a[1]);
      
      //cout<<a[1].x<<' '<<a[1].y<<' '<<m.x<<' '<<m.y<<endl;
      pair <point,point> dr=fprp(a[0],a[1]);
      sq[i].c=a[0];
      sq[i].v1=a[1];
      sq[i].v2=m;
      if(sq[i].v1.x>sq[i].v2.x)
       swap(sq[i].v1,sq[i].v2);
      sq[i].v3=dr.first;
      sq[i].v4=dr.second;
      if(sq[i].v3.x>sq[i].v4.x)
       swap(sq[i].v3,sq[i].v4);
    }
    int j;  
    for(i=0;i<n;i++)
     for(j=i+1;j<n;j++)
      if(is(sq[i],sq[j])||is(sq[j],sq[i]))
       {d[i][j]=1;d[j][i]=1;}
     //memset(dp,9999999,sizeof(dp));
     //cout<<d[0][1]<<' '<<d[1][2]<<endl;
     bfs();  
     //cout<<used[n-1]<<endl;
    if(used[n-1]==0)
     cout<<-1<<"\n";
     else cout<<used[n-1]-1<<"\n";
     
      //cout<<dr.first.x<<' '<<dr.first.y<<' '<<dr.second.x<<' '<<dr.second.y<<endl;
    //cout<<x1.x<<' '<<x1.y<<' '<<x2.x<<' '<<x2.y<<endl;
    
}
