/*
TASK:square
LANG:C++
*/
#include <cstdio>
#include <iostream>
using namespace std;
typedef struct
	{
		int xm,ym;
		int x1,y1;
		int x2,y2;
		int x3,y3;
		int x4,y4;
	}square;

square a[1024];
int n;
int g[1024][1024]={0,0};
int q[1024]={0},fr=0,rr=0;
int used[1024]={0};

void input ();
square find_all (square);
bool check (square,square);
bool in (int,int,square,int*);
int d (int,int,int,int,int,int);
void BFS ();
void wall (int,int,int,int,int,int,int*,int);

int main ()
{
	input ();	
	BFS ();
	
	return 0;
}

void input ()
{
	int i,j;
	
	scanf ("%d",&n);
	for (i=0;i<n;i++)
		{
			scanf ("%d %d %d %d",&a[i].xm,&a[i].ym,&a[i].x1,&a[i].y1);
			a[i]=find_all (a[i]);
			for (j=0;j<i;j++)
				{
					if (check (a[i],a[j]))
						{
							g[i][++g[i][0]]=j;
							g[j][++g[j][0]]=i;
						}
				}
		}
	
	return;
}

square find_all (square s)
{
	int tx1,tx2,ty1,ty2,dx,dy;
	
	s.x3=2*s.xm-s.x1;
	s.y3=2*s.ym-s.y1;
	
	tx1=s.y1;
	ty1=-s.x1;
	tx2=s.y3;
	ty2=-s.x3;
	dx=tx2-tx1;
	dy=ty2-ty1;
	
	s.x4=s.xm+dx/2;
	s.y4=s.ym+dy/2;
	
	s.x2=s.xm-dx/2;
	s.y2=s.ym-dy/2;
	
	return s;
}

bool check (square s1,square s2)
{
	int w1=0,vis[8],w,sum=0,fl=0;
	vis[1]=vis[2]=vis[3]=vis[4]=0;
	
	if (in (s1.x1,s1.y1,s2,&w1))
		return true;
	if (in (s1.x2,s1.y2,s2,&w1))
		return true;
	if (in (s1.x3,s1.y3,s2,&w1))
		return true;
	if (in (s1.x4,s1.y4,s2,&w1))
		return true;
	
	w=w1;
	while (w!=0)
		{
			if (vis[w%10])
				fl++;
			vis[w%10]++;
			sum++;
			w/=10;
		}
	
	if (sum==8)
		return true;
	if (fl)
		return false;
	if (w1>10 && (w1/10)!=(w1%10))
		return true;
	
	sum=0;
	fl=0;
	w1=0;
	vis[1]=vis[2]=vis[3]=vis[4]=0;
	if (in (s2.x1,s2.y1,s1,&w1))
		return true;
	if (in (s2.x2,s2.y2,s1,&w1))
		return true;
	if (in (s2.x3,s2.y3,s1,&w1))
		return true;
	if (in (s2.x4,s2.y4,s1,&w1))
		return true;
		
	
	w=w1;
	while (w!=0)
		{
			if (vis[w%10])
				fl++;
			vis[w%10]++;
			sum++;
			w/=10;
		}
	
	if (sum==8)
		return true;
	if (fl)
		return false;
	if (w1>10 && (w1/10)!=(w1%10))
		return true;
			
	return false;
}

bool in (int x,int y,square s1,int *w1)
{
	int plus=0,minus=0,d1,d2,d3,d4,x1,y1,x2,y2;
	
	d1=d(s1.x1,s1.y1,s1.x2,s1.y2,x,y);
	if (d1>0) plus++;
	if (d1<0) minus++;
	if (d1==0) 
		{
			x1=s1.x1;
			x2=s1.x2;
			if (x1>x2)
				swap (x1,x2);
			y1=s1.y1;
			y2=s1.y2;
			if (y1>y2)
				swap (y1,y2);
			if (x>=x1 && x<=x2 && y>=y1 && y<=y2)
				*w1=(*w1)*10+1;
		}
	d2=d(s1.x2,s1.y2,s1.x3,s1.y3,x,y);
	if (d2>0) plus++;
	if (d2<0) minus++;
	if (d2==0)
		{
			x1=s1.x2;
			x2=s1.x3;
			if (x1>x2)
				swap (x1,x2);
			y1=s1.y2;
			y2=s1.y3;
			if (y1>y2)
				swap (y1,y2);
			if (x>=x1 && x<=x2 && y>=y1 && y<=y2)
				*w1=(*w1)*10+2;
		}
	d3=d(s1.x3,s1.y3,s1.x4,s1.y4,x,y);
	if (d3>0) plus++;
	if (d3<0) minus++;
	if (d3==0)
		{
			x1=s1.x3;
			x2=s1.x4;
			if (x1>x2)
				swap (x1,x2);
			y1=s1.y3;
			y2=s1.y4;
			if (y1>y2)
				swap (y1,y2);
			if (x>=x1 && x<=x2 && y>=y1 && y<=y2)
				*w1=(*w1)*10+3;
		}
	d4=d(s1.x4,s1.y4,s1.x1,s1.y1,x,y);
	if (d4>0) plus++;
	if (d4<0) minus++;
	if (d4==0)
		{
			x1=s1.x4;
			x2=s1.x1;
			if (x1>x2)
				swap (x1,x2);
			y1=s1.y4;
			y2=s1.y1;
			if (y1>y2)
				swap (y1,y2);
			if (x>=x1 && x<=x2 && y>=y1 && y<=y2)
				*w1=(*w1)*10+4;
		}
	
	if (plus==4)
		return true;
	if (minus==4)
		return true;
	return false;
}

int d (int x1,int y1,int x2,int y2,int x3,int y3)
{
	int dx1=x2-x1;
	int dx2=x3-x2;
	int dy1=y2-y1;
	int dy2=y3-y2;
	int d=dx1*dy2-dx2*dy1;
	
	if (d>0)
		return 1;
	if (d<0)
		return -1;
	return 0;
}

void BFS ()
{
	int x,i,j;
	
	q[fr]=0;
	fr++;
	used[0]=1;
	while (fr!=rr)
		{
			x=q[rr];
			rr++;
			for (i=1;i<=g[x][0];i++)
				{
					if (!used[g[x][i]])
						{
							used[g[x][i]]=used[x]+1;
							q[fr]=g[x][i];
							fr++;
						}
					if (used[n-1]!=0)
						{
							printf ("%d\n",used[n-1]-1);
							return;
						}
				}
		}
	printf ("-1\n");
	
	return;
}

