/*
TASK: square
LANG: C++
*/
#include<stdio.h>
#define det(x1,y1,x2,y2,x3,y3) x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2)
#define abs(a) a<0?-a:a
#define dist(x1,x2,y1,y2) (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)
#define swp(a,b) a+=b,b=a-b,a=a-b
using namespace std;
typedef struct point
{
 int x;
 int y;    
};
struct square{
 point A;
 point B;
 point C;
 point D;
};
int used[1001]={0};
square s[1001];
int sign(int x);
bool check(int i,int j);
bool cmp(point a,point b);
int main()
{
 int n,i,j,k,Ox,Oy,x,y;
 scanf("%d",&n);
 for(i=0;i<n;i++)
 {
  scanf("%d%d%d%d",&Ox,&Oy,&s[i].A.x,&s[i].A.y);
 
  x=Ox-s[i].A.x;
  x=abs(x);
  y=Oy-s[i].A.y;
  y=abs(y);
 if(s[i].A.x>Ox)
  if(s[i].A.y>Oy)
   {
    s[i].C.x=Ox-x;
    s[i].C.y=Oy-y;
    
    s[i].B.x=Ox-y;
    s[i].B.y=Oy+x;
    
    s[i].D.x=Ox+y;
    s[i].D.y=Oy-x;
   }
  else
   {
    s[i].C.x=Ox-x;
    s[i].C.y=Oy+y;
    
    s[i].D.x=Ox-y;
    s[i].D.y=Oy-x;
    
    s[i].B.x=Ox+y;
    s[i].B.y=Oy+x;
   }
 else 
  if(s[i].A.y>Oy)
   {
    s[i].C.x=Ox+x;
    s[i].C.y=Oy-y;
    
    s[i].B.x=Ox-y;
    s[i].B.y=Oy-x;
    
    s[i].D.x=Ox+y;
    s[i].D.y=Oy+x;
   }
  else
   {
    s[i].C.x=Ox+x;
    s[i].C.y=Oy+y;
    
    s[i].B.x=Ox+y;
    s[i].B.y=Oy-x;
    
    s[i].D.x=Ox-y;
    s[i].D.y=Oy+x;
   }
   for(j=0;j<i;j++)
   if(check(j,i)){
     if(used[i]>(used[j]+1)||used[i]==0)used[i]=used[j]+1;
   if(j==0)used[i]=1;
 }}
 printf("%d\n",used[n-1]);
 return 0;
}
bool check(int i,int j)
{
 if(dist(s[i].A.x,s[i].A.y,s[i].B.x,s[i].B.y)>
    dist(s[j].A.x,s[j].A.y,s[j].B.x,s[j].B.y)
   )swp(i,j);

 int ABA,ABB,ABC,ABD,BCA,BCB,BCD,BCC,CDA,CDB,CDC,CDD,DAB,DAA,DAC,DAD;

 ABA=det(s[j].A.x,s[j].A.y,s[j].B.x,s[j].B.y,s[i].A.x,s[i].A.y);
 ABB=det(s[j].A.x,s[j].A.y,s[j].B.x,s[j].B.y,s[i].B.x,s[i].B.y);
 ABC=det(s[j].A.x,s[j].A.y,s[j].B.x,s[j].B.y,s[i].C.x,s[i].C.y);
 ABD=det(s[j].A.x,s[j].A.y,s[j].B.x,s[j].B.y,s[i].D.x,s[i].D.y);

 BCA=det(s[j].B.x,s[j].B.y,s[j].C.x,s[j].C.y,s[i].A.x,s[i].A.y);
 BCB=det(s[j].B.x,s[j].B.y,s[j].C.x,s[j].C.y,s[i].B.x,s[i].B.y);
 BCC=det(s[j].B.x,s[j].B.y,s[j].C.x,s[j].C.y,s[i].C.x,s[i].C.y);
 BCD=det(s[j].B.x,s[j].B.y,s[j].C.x,s[j].C.y,s[i].D.x,s[i].D.y);
    
 CDA=det(s[j].C.x,s[j].C.y,s[j].D.x,s[j].D.y,s[i].A.x,s[i].A.y);
 CDB=det(s[j].C.x,s[j].C.y,s[j].D.x,s[j].D.y,s[i].B.x,s[i].B.y);
 CDC=det(s[j].C.x,s[j].C.y,s[j].D.x,s[j].D.y,s[i].C.x,s[i].C.y);
 CDD=det(s[j].C.x,s[j].C.y,s[j].D.x,s[j].D.y,s[i].D.x,s[i].D.y);
    
 DAA=det(s[j].D.x,s[j].D.y,s[j].A.x,s[j].A.y,s[i].A.x,s[i].A.y);
 DAB=det(s[j].D.x,s[j].D.y,s[j].A.x,s[j].A.y,s[i].B.x,s[i].B.y);
 DAC=det(s[j].D.x,s[j].D.y,s[j].A.x,s[j].A.y,s[i].C.x,s[i].C.y);
 DAD=det(s[j].D.x,s[j].D.y,s[j].A.x,s[j].A.y,s[i].D.x,s[i].D.y);
 
 ABA=sign(ABA);
 ABB=sign(ABB);
 ABC=sign(ABC);
 ABD=sign(ABD);
 BCA=sign(BCA);
 BCB=sign(BCB);
 BCC=sign(BCC);
 BCD=sign(BCD);
 CDA=sign(CDA);
 CDB=sign(CDB);
 CDC=sign(CDC);
 CDD=sign(CDD);
 DAA=sign(DAA);
 DAB=sign(DAB);
 DAC=sign(DAC);
 DAD=sign(DAD);
 
 if(ABA==ABB==ABC==ABD==BCA==BCB==BCD==BCC==CDA==CDB==CDC==CDD==DAB==DAA==DAC==DAD)return true;//i e vutre6en za j

 if((ABB!=ABD)&&                                         //------------
    (BCA==BCB==BCD==BCC==DAB==DAA==DAC==DAD))return true;//i presi4a j SAMO PREZ AB
 if ((ABB!=ABD)&&                                        //prez AB i BC/AD 
    (BCA!=BCB)||(DAB!=DAA))return true;                  //------------

 if((CDB!=CDD)&&                                          //------------
    (BCA==BCB==BCD==BCC==DAB==DAA==DAC==DAD))return true;//i presi4a j SAMO PREZ CD
 if((CDB!=CDD)&&                                          //prez CD i BC/AD 
    (BCA!=BCB)||(DAD!=DAA))return true;                  //------------
 
 if((BCA!=BCC)&&                                         //------------
    (ABA==ABB==ABD==ABC==CDB==CDA==CDC==CDD))return true;//i presi4a j samo prez BC  

 if((DAA!=DAC)&&                                         //------------
    (ABA==ABB==ABD==ABC==CDB==CDA==CDC==CDD))return true;//i presi4a j samo prez AD  

 return false;
}
bool cmp(point b,point a)
{if(a.x>b.x)return true;
 if(a.x==b.x&&a.y>b.y)return true;
 return false;
}
int sign(int x)
{
 if(x<0)return -1;
 if(x>0)return 1;
 return 0;
}
