/*
LANG:C++
TASK:square
*/
#include <iostream>
#include <cmath>
#include <queue>
using namespace std;
double rad = 180.0/M_PI;
queue <int> q;
queue <int> br;
struct P
{
	double x,y;
};
struct SQ
{
	P cen;
	P ver[10];
};
SQ sqr[1001];
P p1;
int N;

double dist(P p1,P p2)
	{
		return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
	}

double SP(P p1,P p2,P p3)
	{
			double w,u,w1,u1;
				w=p2.x-p1.x;
				w1=p3.x-p1.x;
				u=p2.y-p1.y;
				u1=p3.y-p1.y;
				return w*u1-w1*u;
	}

bool edge(int i,int j)
	{
		int k,l;
		bool s=1;
			
			for(k=1;k<=4;k++)
				{
				//	double k=1.0;
					s=1;
				
					double hp=SP(sqr[j].cen,sqr[j].ver[1],sqr[j].ver[2]);
					//					cout<<k<<endl;
		
					for(l=1;l<=4;l++)
						//k*=SP(i.cen,j.ver[l],j.ver[l+1]);
							if(hp*SP(sqr[i].ver[k],sqr[j].ver[l],sqr[j].ver[l+1])<=0) {s=0; break;} 
						//cout<<SP(i.cen,i.ver[l],i.ver[l+1])<<endl;
				if(s==1) return 1;
					
					s=1;
						p1.x=(sqr[i].ver[k].x+sqr[i].ver[k+1].x)/2;
						p1.y=(sqr[i].ver[k].y+sqr[i].ver[k+1].y)/2;
						if(abs(p1.x)<0.000001) p1.x=0.0;
						if(abs(p1.y)<0.000001) p1.y=0.0;
							
					//	cout<<p1.x<<" "<<p1.y<<endl;
					for(l=1;l<=4;l++)
					{
					//	s=1;
						
						//cout<<k<<endl;
		
							if(hp*SP(p1,sqr[j].ver[l],sqr[j].ver[l+1])<=0) {s=0; break;} 	
					}
					
					if(s==1) return 1;
				}
		swap(i,j);
					

				for(k=1;k<=4;k++)
				{
				//	double k=1.0;
					s=1;
					double hp=SP(sqr[j].cen,sqr[j].ver[1],sqr[j].ver[2]);
					for(l=1;l<=4;l++)
						//k*=SP(i.cen,j.ver[l],j.ver[l+1]);
							if(hp*SP(sqr[i].ver[k],sqr[j].ver[l],sqr[j].ver[l+1])<=0) {s=0; break;} 
						//cout<<SP(i.cen,i.ver[l],i.ver[l+1])<<endl;
				//	cout<<k<<endl;
					if(s==1) return 1;
					
					s=1;
						p1.x=(sqr[i].ver[k].x+sqr[i].ver[k+1].x)/2;
						p1.y=(sqr[i].ver[k].y+sqr[i].ver[k+1].y)/2;
						if(abs(p1.x)<0.000001) p1.x=0.0;
						if(abs(p1.y)<0.000001) p1.y=0.0;
							
					//	cout<<p1.x<<" "<<p1.y<<endl;
					for(l=1;l<=4;l++)
					{
					//	s=1;
						
						//cout<<k<<endl;
		
							if(hp*SP(p1,sqr[j].ver[l],sqr[j].ver[l+1])<=0) {s=0; break;} 	
					}
					
					if(s==1) return 1;
				}
				
				
			return 0;		
	}

void makesqr(int i)
	{
		double r=dist(sqr[i].cen,sqr[i].ver[1]);
	//	cout<<r<<endl;
		double cosa,sina;
		cosa=(sqr[i].ver[1].x-sqr[i].cen.x)/r;
	//	sina=(sqr[i].ver[1].y-sqr[i].cen.y)/r;
		double a=acos(cosa)*rad;
		
			if(sqr[i].cen.y>sqr[i].ver[1].y)
				a=(360.0-a);
				//if(a<0.000001) a=0.0;
		//cout<<a<<endl;
		int j;
			for(j=1;j<=3;j++)
				{
					a+=90.0;
						if(a>360.0)
							a-=360.0;
						sqr[i].ver[j+1].x=sqr[i].cen.x+cos(a/rad)*r;
						if(abs(sqr[i].ver[j+1].x)<0.000001) sqr[i].ver[j+1].x=0.0;
						sqr[i].ver[j+1].y=sqr[i].cen.y+sin(a/rad)*r;
						if(abs(sqr[i].ver[j+1].y)<0.000001) sqr[i].ver[j+1].y=0.0;
						
				}
				sqr[i].ver[5]=sqr[i].ver[1];
		//cout<<asin(sina)*rad+360.0<<endl;
	}
bool u[1001];

void bfs()
	{
		int v=1;
		int br1=1;
		u[v]=1;
		br.push(1);
			q.push(v);
				while(!q.empty())
					{
						v=q.front();
					//	cout<<v<<endl;
						br1=br.front();
						if(v==N) {
							cout<<br1-1<<endl;
							exit(0);
						}
						u[v]=1;
						
							int i;
								for(i=1;i<=N;i++)
									{
										if(u[i]==1) continue;
									//	cout<<v<<" "<<i<<endl;
										//edge(v,i);
										
										if(edge(v,i))
											{
											
												q.push(i);
												u[i]=1;
												br.push(br1+1);
											}
									}
							q.pop();	
							br.pop();	
					}
	}

int main()
{
	int i;
			scanf("%d",&N);
				for(i=1;i<=N;i++)
					{
						scanf("%lf %lf %lf %lf",&sqr[i].cen.x,&sqr[i].cen.y,&sqr[i].ver[1].x,&sqr[i].ver[1].y);
					//	cout<<sqr[i].cen.x<<" "<<sqr[i].cen.y<<endl;
					}
			for(i=1;i<=N;i++)
				makesqr(i);	
			//	sqr[1].cen.x=10.0;
				//sqr[1].cen.y=10.0;
			//	cout<<edge(1,3)<<endl;	
			bfs();
			cout<<"-1"<<endl;
		/*		int j;
			for(i=1;i<=N;i++)
				{
					for(j=1;j<=4;j++)
						cout<<sqr[i].ver[j].x<<" "<<sqr[i].ver[j].y<<endl;
						//printf("%.5lf %.5lf\n",sqr[i].ver[j].x,sqr[i].ver[j].y);
				}*/
//	cout<<sin(180/rad)<<endl;
		//printf("%.5lf\n",sin(180/rad));
	//system("pause");
	return 0;
}
