/*
TASK:square
LANG:C++
*/
#include <iostream>
#include <vector>
#include <math.h>
using namespace std;
struct point
{
	float x,y;
};
point pts[1024][4];

int n;
vector<int> gr[1024];

float CP(point p0,point p1,point p2)
{
	float dx1=p1.x-p0.x;
	float dx2=p2.x-p0.x;
	float dy1=p1.y-p0.y;
	float dy2=p2.y-p0.y;
		return dx1*dy2-dx2*dy1;
}

void buildGraph()
{
	int sina,cosa,sinfi,cosfi;
	for(int i=1;i<n;i++)
		for(int j=i+1;j<=n;j++)
		{
			bool flag=0;
			
			for(int k=0;k<4;k++)
			{
				if(CP(pts[j][0],pts[j][1],pts[i][k])>0 && CP(pts[j][1],pts[j][2],pts[i][k])>0 && CP(pts[j][2],pts[j][3],pts[i][k])>0 && CP(pts[j][3],pts[j][0],pts[i][k])>0)
					flag=1; 	
			}			
			
			if(flag)
			{
				gr[i].push_back(j);
				gr[j].push_back(i);	
			}
		}
}
int q[1024];
bool used[1024];
int br[1024];
void bfs()
{
	int fst=1,lst=1;
	used[1]=1;
	q[1]=1;
	br[1]=0;
	
	do
	{
		for(int i=0;i<gr[q[fst]].size();i++)
			if(!used[gr[q[fst]][i]])
			{
				q[++lst]=gr[q[fst]][i];
				used[gr[q[fst]][i]]=1;
				br[lst]=br[fst]+1;
				if(q[lst]==n) {cout<<br[lst]<<endl;return;}
			}
		fst++;
	}
	while(fst<=lst);
	cout<<"-1"<<endl;
}
	float a,b,c,d;
		float sina,cosa,sinfi,cosfi,dist;
		
int main()
{

	cin>>n;

	for(int i=1;i<=n;i++)
	{
		cin>>a>>b>>c>>d;
		
		dist=sqrt((c-a)*(c-a)+(d-b)*(d-b));
		sina=(d-b)/dist;
		cosa=(c-a)/dist;
	
	//	cout<<dist<<"("<<sina<<" "<<cosa<<")";
		cout<<"";

		sinfi=cosa;
		cosfi=-sina;
		
		pts[i][0].x=c;
		pts[i][0].y=d;
		
		pts[i][1].x=a+dist*cosfi;
		pts[i][1].y=b+dist*sinfi;
	
		pts[i][2].x=a-(c-a);
		pts[i][2].y=b-(d-b);
		
		pts[i][3].x=a-(pts[i][1].x -a);
		pts[i][3].y=b-(pts[i][1].y -b);
		
		
		
//	for(int k=0;k<4;k++)
//		cout<<pts[i][k].x<<" "<<pts[i][k].y<<"|";
//	cout<<endl; 
	}
	
	buildGraph();
	bfs();
}
