/*
TASK: square
LANG: C++
*/
#include <iostream>
#include <cmath>
#include <queue>
#define sqr(a)((a)*(a))
using namespace std;
struct point {short x, y;};
struct square 
{     point A, B, C, D;    // D C
      int r2;              // A B
}sq[1000];  
short N;
bool m[1000][1000];
int dist(point A, point B)
{ return sqr(A.x - B.x) + sqr(A.y - B.y); }
int bfs(int);
bool used[1000];

int main()
{
    cin >> N;
    point c, v;
    short x, y;
    int i, j;
    for (i=0; i < N;i++)
    {
        cin >> c.x >> c.y >> v.x >> v.y;
        x = abs(c.x - v.x);
        y = abs(c.y - v.y);
        sq[i].A.x = c.x - x;
        sq[i].A.y = c.y - y;
        sq[i].C.x = c.x + x;
        sq[i].C.y = c.y + y;
        sq[i].B.x = c.x + y;
        sq[i].B.y = c.y + x;
        sq[i].D.x = c.x - y;
        sq[i].D.y = c.y - x;
        sq[y].r2 = 4 * dist(c, v);
    }
    
    for (i=0;i < N;i++)
     for (j=i+1;j < N;j++)
     {
         bool in = 0;
         // I-th square
            if (dist(sq[i].A, sq[j].A) < sq[j].r2 && dist(sq[i].A, sq[j].B) < sq[j].r2 
             && dist(sq[i].A, sq[j].C) < sq[j].r2 && dist(sq[i].A, sq[j].D) < sq[j].r2) in = true;
            if (dist(sq[i].B, sq[j].A) < sq[j].r2 && dist(sq[i].B, sq[j].B) < sq[j].r2 
             && dist(sq[i].B, sq[j].C) < sq[j].r2 && dist(sq[i].B, sq[j].D) < sq[j].r2) in = true;
            if (dist(sq[i].C, sq[j].A) < sq[j].r2 && dist(sq[i].C, sq[j].B) < sq[j].r2 
             && dist(sq[i].C, sq[j].C) < sq[j].r2 && dist(sq[i].C, sq[j].D) < sq[j].r2) in = true;
            if (dist(sq[i].D, sq[j].A) < sq[j].r2 && dist(sq[i].D, sq[j].B) < sq[j].r2 
             && dist(sq[i].D, sq[j].C) < sq[j].r2 && dist(sq[i].D, sq[j].D) < sq[j].r2) in = true;
         // J-th square
            if (dist(sq[j].A, sq[i].A) < sq[i].r2 && dist(sq[j].A, sq[i].B) < sq[i].r2 
             && dist(sq[j].A, sq[i].C) < sq[i].r2 && dist(sq[j].A, sq[i].D) < sq[i].r2) in = true;
            if (dist(sq[j].B, sq[i].A) < sq[i].r2 && dist(sq[j].B, sq[i].B) < sq[i].r2 
             && dist(sq[j].B, sq[i].C) < sq[i].r2 && dist(sq[j].B, sq[i].D) < sq[i].r2) in = true;
            if (dist(sq[j].C, sq[i].A) < sq[i].r2 && dist(sq[j].C, sq[i].B) < sq[i].r2 
             && dist(sq[j].C, sq[i].C) < sq[i].r2 && dist(sq[j].C, sq[i].D) < sq[i].r2) in = true;
            if (dist(sq[j].D, sq[i].A) < sq[i].r2 && dist(sq[j].D, sq[i].B) < sq[i].r2 
             && dist(sq[j].D, sq[i].C) < sq[i].r2 && dist(sq[j].D, sq[i].D) < sq[i].r2) in = true;
         
         if (in) m[i][j] = m[j][i] = 1;
     }
    
    cout << bfs(0) << endl;
    //system("pause");
    return 0;
}

int bfs(int v)
{
     used[v] = 1;
     queue <int> q;
     q.push(v);
     int lvl = 0, k;
     int popped = 0;
     int chl = 1;
     while (!q.empty());
     {
        k = q.front();
        q.pop();
        popped++; chl--;
        if (popped == chl) { lvl++; popped = 0; chl = 0; }
        if (k == N-1) return lvl;
        
        for (int j=0;j < N;j++)
         if (m[k][j] && !used[j])
         {
            used[j] = 1;
            q.push(j);
            chl++;
         }
     }
     
     return -1;
}
     
