/*
TASK:square
LANG:C
*/


#include<stdio.h>
#include<stdlib.h>

#define pause system("pause")

 struct dot{
  int x,y;
 };
 struct rec{
  struct dot a,b,c,d;
  int disq;
 }A[1024];
 
 int n,mat[1024][1024];
 
 void findrec(int x1, int y1, int x2, int y2, int i)
 {
  int xt,yt;
  xt=x2-x1; yt=y2-y1;
  
  A[i].a.x=x2; A[i].a.y=y2;
  A[i].b.x=x1-yt; A[i].b.y=xt;
  A[i].c.x=x1-xt; A[i].c.y=y1-yt;
  A[i].d.x=x1+yt; A[i].d.y=y1-xt;
  A[i].disq=(A[i].a.x-A[i].c.x)*(A[i].a.x-A[i].c.x)+(A[i].a.y-A[i].c.y)*(A[i].a.y-A[i].c.y);
 }
 
 int cp(struct dot k,struct  dot l,struct  dot m)
 {
  int x1=k.x-l.x;       
  int y1=k.y-l.y;
  int x2=k.x-m.x;
  int y2=k.y-m.y;          
  return x1*y2-x2*y1;      
 }
 
 char pres(struct dot a1,struct dot b1,struct dot a2,struct dot b2)
 {
  int d1,d2,d3,d4;
  d1=cp(a1,a2,b2);
  d2=cp(b1,a2,b2);
  d3=cp(a2,a1,b1);
  d4=cp(b2,a1,b1);       
  if( ((d1>0 && d2<0) || (d2>0 && d1<0)) && ( (d3>0 && d4<0) || (d4>0 && d3<0) ) )return 1;      
//  if(d1==0)if((a1.x<a2.x && a1.x>b2.x) || (a1.x>a2.x && a1.x<b2.x))return 1;      
//  if(d2==0)if((b1.x<a2.x && b1.x>b2.x) || (b1.x>a2.x && b1.x<b2.x))return 1;
//  if(d3==0)if((a2.x<a1.x && a2.x>b1.x) || (a2.x>a1.x && a2.x<b1.x))return 1;
//  if(d4==0)if((b2.x<a1.x && b2.x>b1.x) || (b2.x>a1.x && b2.x<b1.x))return 1;      
  return 0;
 }
 
 char inside(int i, int j)
 {
  int d1,d2,d3;
  d1=cp(A[i].a,A[j].c,A[j].a);
  d2=cp(A[i].a,A[j].a,A[j].b);
  d3=cp(A[i].a,A[j].b,A[j].c);
  if((d1>0 && d2>0 && d3>0) || (d1<0 && d2<0 && d3<0))return 1;
  d2=cp(A[i].a,A[j].a,A[j].d);
  d3=cp(A[i].a,A[j].d,A[j].c);  
  if((d1>0 && d2>0 && d3>0) || (d1<0 && d2<0 && d3<0))return 1;
  return 0;
 }
 
 char presr(int i, int j)
 {
  if(pres(A[i].a,A[i].c,A[j].a,A[j].b))return 1;
  if(pres(A[i].a,A[i].c,A[j].b,A[j].c))return 1;
  if(pres(A[i].a,A[i].c,A[j].c,A[j].d))return 1;
  if(pres(A[i].a,A[i].c,A[j].d,A[j].a))return 1;      
        
  if(pres(A[i].b,A[i].d,A[j].a,A[j].b))return 1;
  if(pres(A[i].b,A[i].d,A[j].b,A[j].c))return 1;
  if(pres(A[i].b,A[i].d,A[j].c,A[j].d))return 1;
  if(pres(A[i].b,A[i].d,A[j].d,A[j].a))return 1;      
  
  if(A[i].disq>A[j].disq && inside(j,i))return 1;
  if(A[j].disq>A[i].disq && inside(i,j))return 1;
  
  return 0;
 }
 
 int bfs()
 {
  char used[1024];
  int i=0,v=0,q[1024],e=1,lev=0,oe=1,j;
  
  q[0]=0; used[0]=1;
  for(v=0;v<=n;v++)used[v]=0;
  
  while(i!=e)
  {
   lev++;
   for(;i<oe;i++)
   {
    v=q[i]; 
    for(j=0;j<n;j++)     
     if(mat[v][j]&& !used[j]){
            used[j]=1; 
            q[e++]=j; 
            if(j==n-1)return lev;
     }   
   }     
   oe=e;     
  }            
  return -1;      
 }
 
 int main()
 {
  int i,x1,y1,x2,y2,j;
  FILE *fi=stdin;//fopen("square.in","r");
  fscanf(fi,"%d",&n);
  
  for(i=0;i<n;i++)
  {
   fscanf(fi,"%d %d %d %d",&x1,&y1,&x2,&y2);
   findrec(x1,y1,x2,y2,i);
   //printf("%d %d %d %d %d %d %d %d\n",A[i].a.x,A[i].a.y,A[i].b.x,A[i].b.y,A[i].c.x,A[i].c.y,A[i].d.x,A[i].d.y);
  }       
  
  for(i=0;i<n-1;i++)
   for(j=i+1;j<n;j++)
    if(presr(i,j))mat[i][j]=mat[j][i]=1;
  
/*  for(i=0;i<n;i++)
   {for(j=0;j<n;j++)
    printf("%d ",mat[i][j]);  
    printf("\n");}*/
    
  printf("%d\n",bfs());  
//  printf("%d",presr(0,1));
  
//  pause;      
  return 0;       
 }
