/*
TASK: egypt
LANG: C++
*/

#include <cstdio>
#include <iostream>
#include <map>

using namespace std;

#define f(i, n) for(int i = 0; i < (n); i ++)
#define ff(i, st, end) for(int i = (st); i < (end); i ++)
#define fv(i, v) for(int i = 0; i < int((v).size()); i ++)
#define fx(i, v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(v) (v).begin(), (v).end()

/* map< pair<pair<int,int>,pair<int,int> >, int > m;

int large(int a, int b, int up, int n)
{
//	std :: cout << a << " " << b << "\n";
	pair<pair<int,int>,pair<int,int> > ind = make_pair( make_pair(a,b),make_pair(up,n));
	if( m.count(ind) )	return m[ind];
	if( a < 0 )	return m[ind] = -1;
	int G = std :: __gcd(a,b); a /= G; b /= G;
	if(n == 1)	return m[ind] = ((a == 1) ? b : -1);
	for(register int i = std::min(up, 3263442); i > 0; i --)
		if( ( (b == 1) || (b % i == 0) ) && (large( - b + a*i, b*i, i, n - 1 ) != -1) )
		{
//			std :: cout << a << " " << b << " " << n << " " << i << "\n";
			return m[ind] = i;
		}
	return m[ind] = -1; 
} */

inline string mply(string a, string b)
{
	if(a.size() < b.size())	return mply(b,a);
	string res(a.size() + b.size(), '0');
	for(register int i = a.size() - 1; i >= 0; i --)
	{
		int cur = 0, carry = 0;
		for(register int j = b.size() - 1; j >= 0; j -- )
		{
			int ind = i + j + 1;
			cur = (a[i] - '0') * (b[j] - '0') + carry + res[ind] - '0';
			carry = cur / 10;
			cur %= 10;
			res[ind] = cur + '0';
			
		}
		if(carry) res[i] += carry;
	}
	if(res[0] == '0')	return res.substr(1);
	return res;
}

inline string add1(string a)
{
	string res = '0' + a;
	register int pos = res.size() - 1;
	while(res[pos] == '9')
		res[pos --] = '0';
	res[pos] ++;
	if(res[0] == '0')	return res.substr(1);
	return res;
}

string solve(int n)
{
	if(n == 1)	return "1";
	string res1 = solve(n - 1), res2 = add1(res1);
	return mply(res1,res2);
}

string a,b;
int n;
int main()
{
	scanf("%d", &n);
//	cout << solve(n) << "\n";
	string res = solve(n);
	printf("%s\n", res.c_str());
//	printf("%d\n", large(1,1, INT_MAX ,n));
//	std :: cout << large(1,1,n) << " " << large(35, 42, n - 1) << "\n";
    return 0;
}
