/*
TASK:lucky
LANG:C++
*/

#include <iostream>
using namespace std;

typedef long long type;

const int MAX    = 14*9+3;
const int DIGITS = 2;

type dp[DIGITS+2][MAX][MAX];

type solve (type a)
{
     int prod_div, prod_mod, digit, sum, d;
     type res=0;
     
     for (prod_div=1; prod_div<MAX; prod_div++) {
         memset (dp,0,sizeof(dp));
         dp[0][0][0] = 1;
         
         for (digit=0; digit<DIGITS; digit++)
             for (d=digit?0:1; d<10; d++)
                 for (sum=0; sum+d<MAX; sum++)
                     for (prod_mod=0; prod_mod<prod_div; prod_mod++)
                         if (dp[digit][sum][prod_mod]) {
                             //for (int t=0; t<10000; t++) a=a*2+t+1;
                             dp[digit+1][sum+d][(prod_mod+d)%prod_div] += dp[digit][sum][prod_mod];
                             //if ((prod_mod+d)%prod_div == 0) printf ("%d %d %d %d: %d\n", digit, d, sum, prod_mod, dp[digit][sum][prod_mod]);
                     }
         
         //printf ("prod_div=%d: %d\n", prod_div, dp[DIGITS][prod_div][0]);
         
         for (sum=1; sum<MAX; sum++)
             if (prod_div%sum==0)
                res += dp[DIGITS][sum][0];
         //break;
     }
    // cout << a;
     return res;
}

int sum (type p)
{
    int res=0;
    for (; p; p/=10) res+=p%10;
    return res;
}

int prod (type p, int mod)
{
    int res=1;
    for (; p; p/=10) res=(res*(p%10))%mod;
    return res;
}

type brute (type a, type b)
{
     int ans=0;
     
     for (; a<=b; a++) {
         if (prod(a,sum(a))==0)
            ans++;
     }
            
     cout << ans << "\n";
}

int main ()
{
    type a, b;
    
    cin >> a >> b;
    brute (a,b);
    return 0;
    
    
    cout << solve (1) << "\n";
    return 0;
    
    cin >> a >> b;
    cout << solve(b)-solve(a-1) << "\n";

    return 0;    
}
