/*
TASK: lucky
LANG: C++
*/
#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAX_DIG = 16;
const int MAX_SUM = 132;

typedef long long ll;
typedef ll type;

type dp[MAX_DIG][MAX_SUM][MAX_SUM][2];

int num ( ll x ) {
    if ( !x ) return 0;
    return num ( x / 10 ) + 1;
}

ll rev ( ll x ) {
    ll ans = 0;
    
    while ( x ) {
        ans = ans * 10 + x % 10;
        x /= 10;
    }
    
    return ans;
}

int cif;
int mod;
int qq[MAX_DIG];

type go ( int dig , int sum , int mul , int edge ) {
    if ( sum < 0 ) return 0;
    if ( !dig ) {
        if ( sum || mul ) return 0;
        return 1;
    }
    if ( dp[dig][sum][mul][edge] != -1 ) return dp[dig][sum][mul][edge];
    type ans = 0;
    int i;
    int mx;
    
    if ( edge ) mx = qq[ dig - 1 ];
    else mx = 9;
    
    for (i=0;i<=mx;i++)
        ans += go ( dig - 1 , sum - i , (mul * i) % mod , edge & (i == mx) );
        
    return dp[dig][sum][mul][edge] = ans;
}

type solve ( ll x ) {
    int i , j , k;
    cif = num ( x );
    ll cur;
    type ans = 0;
    
    cur = x;
    for (i=0;i<cif;i++) {
        qq[i] = cur % 10;
        cur /= 10;
    }
    
    for (i=1;i<MAX_SUM;i++) {
        memset ( dp , -1 , sizeof dp );
        mod = i;
        
        for (j=0;j<cif - 1;j++)
            for (k=1;k<=9;k++)
                ans += go ( j , i - k , k % mod , 0 );
            
        for (k=1;k<=qq[cif - 1];k++)
            ans += go ( cif - 1 , i - k , k % mod , k == qq[cif - 1] );
    }
    
    return ans;
}

int main() {
    ll l , r;
    
    cin >> l >> r;  
    cout << solve( r ) - solve ( l - 1 ) << '\n' ;
    
    return 0;
}
