/*
TASK:square
LANG:C++
*/
#include <stdio.h>
#include <vector>
#include <math.h>
#include <stdlib.h>
#include <queue>

using namespace std;

struct A{
    int x,y,a,b;
};

A m[1001];
vector <int> g[1001];
int n,i,j,sol=1,u[1001];
queue <int> q;

void bfs(int v){
    u[v]=1;
    q.push(v);
    while(!q.empty()){
        v=q.front();
        for(i=0;i<g[v].size();i++){
            if(!u[g[v][i]]){
                if(g[v][i]==n){printf("%d\n",sol);exit(0);}
                u[g[v][i]]=1;
                q.push(g[v][i]);
            }
        }
        q.pop();
        sol++;
    }
}

int main(){
    scanf("%d",&n);
    for(i=1;i<=n;i++){
        scanf("%d %d %d %d",&m[i].x,&m[i].y,&m[i].a,&m[i].b);
        m[i].a=abs(m[i].a-m[i].x);
        m[i].b=abs(m[i].b-m[i].y);
        for(j=1;j<i;j++){
            if(((m[i].a+m[j].a)>abs(m[i].x-m[j].x))&&((m[i].b+m[j].b)>abs(m[i].y-m[j].y))){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    bfs(1);
    printf("-1\n");
    return 0;
}
