/*
TASK: square
LANG: C++
*/
// Iordan Boev SMG
# include <stdio.h>
# include <stdlib.h>
# define MAXK (1<<10)

int n,ans;
struct kvard {
	int x[8],y[8];
} data[MAXK];

int used[MAXK];
int a[MAXK][MAXK];

inline int area(int x1,int y1,int x2,int y2,int x3,int y3) {
	return x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2);	
}

int cross(int p,int q) {
	int ok,ok2;
	for(int i = 1; i <= 5; i++) {
		ok = 1;
		ok2 = 1;
		for(int j = 1; j <= 4; j++) {
			int next=j+1;
			if(j == 4) next = 1;
			if(area(data[p].x[j],data[p].y[j],data[p].x[next],data[p].y[next],data[q].x[i],data[q].y[i])<0 ) {
				ok = -1;
			}
			if(area(data[q].x[j],data[q].y[j],data[q].x[next],data[q].y[next],data[p].x[i],data[p].y[i])<0 ) {
				ok2 = -1;	
			}
		}	
		if(ok == 1 || ok2 == 1) return 1;
	} 
	return 0;
}

void read() {
	int a,b,x,y;
	scanf("%d", &n);	
	for(int i = 0; i < n; i++) {
		scanf("%d %d %d %d", &a,&b,&x,&y);	
		data[i].x[1] = x;
		data[i].y[1] = y;
		data[i].x[5] = a;
		data[i].y[5] = b;
		int d1 = x-a,d2=y-b;
		data[i].x[3] = a-d1;
		data[i].y[3] = b-d2;
		int p1,q1,p2,q2;
		p1 = x-a;
		q1 = y-b;
		p2 = data[i].x[3] - a;
		q2 = data[i].y[3] - b;
		data[i].x[2] = a-q1;
		data[i].y[2] = b+p1;
		data[i].x[4] = a-q2;
		data[i].y[4] = b+p2; 
		//printf("%d %d %d %d %d %d %d %d\n", data[i].x[1],data[i].y[1],data[i].x[2],data[i].y[2],data[i].x[3],data[i].y[3],data[i].x[4],data[i].y[4]);
	}
}

void bfs() {
	int queue[MAXK],start,end,level;
	queue[0] = 1;
	used[1] = 1;
	start = 0;
	level = 1;
	end = 1;
	while(end > start) {
		for(int i = start; i < level; i++) {
			if(queue[i] == n) {printf("%d\n",ans); exit(0);}
			used[queue[i]] = 1;
			for(int j = 1; j <= n; j++) {
				if(a[queue[i]][j] == 1 && used[j] == 0) queue[end++] = j;	
			}
		}
		ans++;
		start = level;
		level = end;			
	}
	printf("-1\n");
}

void solve() {
	for(int i = 0; i < n-1; i++) {
		for(int j = i+1; j < n; j++) {
			a[i+1][j+1] = cross(i,j);
			a[j+1][i+1] = a[i+1][j+1];
		}
	}
	/*
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= n; j++) {
			printf("%d ", a[i][j]);
		}
		printf("\n");
	}*/
	bfs();
}	

int main() {
	read();
	solve();
	return 0;
}
